; ID: 2572
; Author: Bobysait
; Date: 2009-08-26 13:43:35
; Title: TForm Vector
; Description: TForm Vector using GetMatElement

Global TFormedX_#=0.0
Global TFormedY_#=0.0
Global TFormedZ_#=0.0

Function TFormedX_#() Return TFormedX_ End Function
Function TFormedY_#() Return TFormedY_ End Function
Function TFormedZ_#() Return TFormedZ_ End Function

Function TFormVector_(vx#,vy#,vz#, FromEntity%,ToEntity%=0)

	Local vx_#,vy_#,vz_#
	If FromEntity<>0
		vx_= vx* GetMatElement(FromEntity,0,0) + vy * GetMatElement(FromEntity,1,0)+ vz* GetMatElement(FromEntity,2,0)
		vy_= vx* GetMatElement(FromEntity,0,1) + vy * GetMatElement(FromEntity,1,1)+ vz* GetMatElement(FromEntity,2,1)
		vz_= vx* GetMatElement(FromEntity,0,2) + vy * GetMatElement(FromEntity,1,2)+ vz* GetMatElement(FromEntity,2,2)
		vx = vx_
		vy = vy_
		vz = vz_
	EndIf
	If ToEntity<>0
		vx_= vx* GetMatElement(ToEntity,0,0) + vy * GetMatElement(ToEntity,0,1)+ vz* GetMatElement(ToEntity,0,2)
		vy_= vx* GetMatElement(ToEntity,1,0) + vy * GetMatElement(ToEntity,1,1)+ vz* GetMatElement(ToEntity,1,2)
		vz_= vx* GetMatElement(ToEntity,2,0) + vy * GetMatElement(ToEntity,2,1)+ vz* GetMatElement(ToEntity,2,2)
		vx = vx_
		vy = vy_
		vz = vz_
	EndIf

	TFormedX_=vx
	TFormedY_=vy
	TFormedZ_=vz

End Function

