' ID: 2588
' Author: GfK
' Date: 2009-09-23 11:26:21
' Title: Visible collision layers
' Description: Generates a PNG format visualisation of a collision layer

Function viewCollisionLayer(width:Int,height:Int,layerID:Int,filename:String)
	Local p:TPixmap = CreatePixmap(width,height, PF_RGBA8888)
        SetScale 1,1
	For x = 0 To width-1
		For y = 0 To height-1
			If CollideRect(x, y, 1, 1, layerID, 0)
				WritePixel(p, x, y, $FFFFFFFF)
			Else
				WritePixel(p, x, y, $FF000000)
			EndIf
		Next
	Next
	SavePixmapPNG(p, filename)
	End
End Function

