; ID: 2134
; Author: Madk
; Date: 2007-11-02 21:25:36
; Title: Polygon and Star functions
; Description: Easily draw basic shapes on the fly!

;*-------------------------------------------------------*;
;*--Polygon and Star functions coded by Madk on 11-2-07--*;
;*-------------------------------------------------------*;

;   No credit is needed for use of these functions.



Dim B3DM_xp(359),B3DM_yp(359) ;These arrays must be declared at start of code for the functions to work.



;Example Usage
Graphics 640,480,0,2

Color 255,255,255
Repeat
	Flip
	
	LockBuffer()
	
	For a=5 To 8
		Polygon 70+(a-4)*100, 100, 70, 70, a, -90
		Star    70+(a-4)*100, 100, 70, 70, a, -90
	Next
	
	UnlockBuffer()
	
	Flip
	If KeyDown(1) End
Forever


;Polygon draws a shape with the specified number of sides
;Polygon ( x position, y position, width, height, number of sides[, angle at which to draw = 0] )
Function Polygon(x#,y#,w#,h#,s%,ang#=0)
	If s>360 Then s=360
	s=s-1:w=w/2:h=h/2
	For dop=0 To s
		B3DM_xp(dop)=x+w*(Cos((360/(s+1)*dop)+ang))
		B3DM_yp(dop)=y+h*(Sin((360/(s+1)*dop)+ang))
	Next
	For lin=0 To s
		p2=lin+1:If p2>s Then p2=0
		Line B3DM_xp(lin),B3DM_yp(lin),B3DM_xp(p2),B3DM_yp(p2)
	Next
End Function

;Star uses a mathematical formula to connect the points of a ploygon to form a star
;Star ( x position, y position, width, height, number of points[, angle at which to draw = 0] )
Function Star(x#,y#,w#,h#,s%,ang#=0) 
	If s>360 Then s=360
	s=s-1:w=w/2:h=h/2
	For dop=0 To s
		B3DM_xp(dop)=x+w*(Cos((360/(s+1)*dop)+ang))
		B3DM_yp(dop)=y+h*(Sin((360/(s+1)*dop)+ang))
	Next
	For lin=0 To s
		p2=lin+2:If p2=s+1 Then p2=0 ElseIf p2=s+2 Then p2=1
		Line B3DM_xp(lin),B3DM_yp(lin),B3DM_xp(p2),B3DM_yp(p2)
	Next
End Function

