; ID: 1483
; Author: VP
; Date: 2005-10-09 07:24:39
; Title: Scancode mnemonic Const's
; Description: Improve code readability with mnemonic names instead of numbers for Scancode tests.

; Keyboard scancode mnemonic constants file.

Const KEY_ESC = 1
Const KEY_1	= 2
Const KEY_2 = 3
Const KEY_3 = 4
Const KEY_4 = 5
Const KEY_5 = 6
Const KEY_6 = 7
Const KEY_8 = 9
Const KEY_9 = 10
Const KEY_0 = 11
Const KEY_MINUS = 12
Const KEY_EQUALS = 13
Const KEY_BACKSPACE = 14
Const KEY_TAB = 15
Const KEY_Q = 16
Const KEY_W = 17
Const KEY_E = 18
Const KEY_R = 19
Const KEY_T = 20
Const KEY_Y = 21
Const KEY_U = 22
Const KEY_I = 23
Const KEY_O = 24
Const KEY_P = 25
Const KEY_LEFTBRACKET = 26
Const KEY_RIGHTBRACKET = 27
Const KEY_ENTER = 28
Const KEY_LEFTCONTROL = 29
Const KEY_A = 30
Const KEY_S = 31
Const KEY_D = 32
Const KEY_F = 33
Const KEY_G = 34
Const KEY_H = 35
Const KEY_J = 36
Const KEY_K = 37
Const KEY_L = 38
Const KEY_SEMICOLON = 39
Const KEY_APOS = 40
Const KEY_GRAVE = 41
Const KEY_LSHIFT = 42
Const KEY_BACKSLASH = 43
Const KEY_Z = 44
Const KEY_X = 45
Const KEY_C = 46
Const KEY_V = 47
Const KEY_B = 48
Const KEY_N = 49
Const KEY_M = 50
Const KEY_COMMA = 51
Const KEY_FULLSTOP = 52
Const KEY_SLASH = 53
Const KEY_RSHIFT = 54
Const KEY_NUM_ASTERISK = 55
Const KEY_LALT = 56
Const KEY_SPACE = 57
Const KEY_CAPITAL = 58
Const KEY_F1 = 59
Const KEY_F2 = 60
Const KEY_F3 = 61
Const KEY_F4 = 62
Const KEY_F5 = 63
Const KEY_F6 = 64
Const KEY_F7 = 65
Const KEY_F8 = 66
Const KEY_F9 = 67
Const KEY_F10 = 68
Const KEY_NUMLOCK = 69
Const KEY_SCRLOCK = 70
Const KEY_NUM_7 = 71
Const KEY_NUM_8 = 72
Const KEY_NUM_9 = 73
Const KEY_NUM_MINUS = 74
Const KEY_NUM_4 = 75
Const KEY_NUM_5 = 76
Const KEY_NUM_6 = 77
Const KEY_NUM_ADD = 78
Const KEY_NUM_1 = 79
Const KEY_NUM_2 = 80
Const KEY_NUM_3 = 81
Const KEY_NUM_0 = 82
Const KEY_NUM_DECIMAL = 83
Const KEY_OEM_102 = 86		; UK and German keyboards.
Const KEY_F11 = 87
Const KEY_F12 = 88
Const KEY_F13 = 100			; NEC PC98.
Const KEY_F14 = 101			; NEC PC98.
Const KEY_F15 = 102			; NEC PC98.
Const KEY_KANA = 112		; Japanese keyboard.
Const KEY_ABNT_C1 = 115		; Upside-down ? on Portugese keyboard.
Const KEY_CONVERT = 121		; Japanese keyboard.
Const KEY_NOCONVERT = 123	; Japanese keyboard.
Const KEY_YEN = 125			; Japanese keyboard.
Const KEY_ABNT_2 = 126		; Numpad '.' on Portugese keyboard.
Const KEY_NUM_EQUALS = 141	; NEC PC98 has an equals key on the numeric keypad.
Const KEY_PREVTRACK = 144	; Previous track (DIK_CIRCUMFLEX on Japanese keyboard).
Const KEY_AT = 145			; NEC PC98.
Const KEY_COLON = 146		; NEC PC98.
Const KEY_UNDERLINE = 147	; NEC PC98.
Const KEY_KANJI = 148		; Japanese keyboard.
Const KEY_STOP = 149		; NEC PC98.
Const KEY_AX = 150			; Japanese AX.
Const KEY_UNLABELED = 151	; J3100 (err, what?).
Const KEY_NEXTTRACK = 153
Const KEY_NUM_ENTER = 156
Const KEY_RCONTROL = 157
Const KEY_MUTE = 160
Const KEY_CALCULATOR = 161
Const KEY_PLAYPAUSE = 162
Const KEY_MEDIASTOP = 164
Const KEY_VOLDOWN = 174
Const KEY_VOLUP = 176
Const KEY_WEBHOME = 178
Const KEY_NUM_COMMA = 179	; NEC PC98 has a comma key on the numeric pad.
Const KEY_NUM_DIVIDE = 181
Const KEY_SYSREQ = 183
Const KEY_RALT = 184
Const KEY_PAUSE = 197
Const KEY_HOME = 199
Const KEY_UP = 200
Const KEY_PGUP = 201
Const KEY_LEFT = 203
Const KEY_RIGHT = 205
Const KEY_END = 207
Const KEY_DOWN = 208
Const KEY_NEXT = 209
Const KEY_INSERT = 210
Const KEY_DELETE = 211
Const KEY_LWIN = 219
Const KEY_RWIN = 220
Const KEY_APPS = 221
Const KEY_POWER = 222
Const KEY_SLEEP = 223
Const KEY_WAKE = 227
Const KEY_WEB_SEARCH = 229
Const KEY_WEB_FAV = 230
Const KEY_WEB_REFRESH = 231
Const KEY_WEB_STOP = 232
Const KEY_WEB_FORWARD = 233
Const KEY_WEB_BACK = 234
Const KEY_MYCOMP = 235
Const KEY_MAIL = 236
Const KEY_MEDIASELECT = 237

