' ID: 2890
' Author: Madk
' Date: 2011-09-23 09:34:41
' Title: Flags
' Description: for those like me who are too OCD to waste those extra bits

Rem

This code is public domain. It is originally by Sophie Kirschner, AKA Madk.
No credit is required for any application or usage of this code.


Flags.Create:Flags(capacity%) - create a new Flags object that contains at least <capacity%> flags
flag.Set(index%,bit:Byte) - set the flag at <index%> to a boolean <bit:Byte>
flag.Get:Byte(index%) - return the boolean flag at <index%>

EndRem

Type Flags
	Field bytes@[]
	Method Set(index%,bit@)
		If (Not Get(index)) And bit
			bytes[index/8]:-(1 Shl (index Mod 8))
		ElseIf Get(index) And (Not bit)
			bytes[index/8]:+(1 Shl (index Mod 8))
		EndIf
	End Method
	Method Get@(index%)
		Return (bytes[index/8] Shr (index Mod 8)) Mod 2
	End Method
	Function Create:Flags(capacity%) 'capacity is in # of flags.
		capacity=capacity/8+1
		Local this:Flags=New Flags
		this.bytes=this.bytes[..capacity]
		Return this
	End Function
End Type




'Example

Local f:flags=flags.Create(4)
f.set 0,1
f.set 1,1
f.set 2,0
f.set 3,1
Print "flag 0: "+f.get(0)
Print "flag 1: "+f.get(1)
Print "flag 2: "+f.get(2)
Print "flag 3: "+f.get(3)
Input("")
End

