' ID: 1933
' Author: GfK
' Date: 2007-02-23 01:29:18
' Title: MouseXSpeed(), MouseYSpeed()
' Description: Add Mouse speed functionality to BlitzMax

Graphics 640,480

Global mouse:tMouse = New tMouse

While Not KeyDown(key_escape)
	Cls
		DrawText "Xspeed: "+ mouse.mouseXSpeed(),10,10
		DrawText "Yspeed: " + mouse.mouseYSpeed(),10,25
		mouse.update()
	Flip
Wend



Type tMouse
	Field lastX:Int
	Field lastY:Int
	Method mouseXSpeed:Int()
		Return MouseX() - lastX
	End Method
	Method mouseYSpeed:Int()
		Return MouseY() - lastY
	End Method
	Method update()
		lastx = MouseX()
		lasty = MouseY()
	End Method
End Type

